# coding: utf-8

#===============================================================================
#
#	Class: TrueLegacyGraphicsCommon
#
class TrueLegacyGraphicsCommon

	def initialize(h_dmy, w_dmy, y_dmy, x_dmy, gy = 400, gx = 640, cy = 16, cx = 8, c = 0, out = {})
		raise('method MAST overload.')
	end

	def fill(x1, y1, x2, y2, c)
		raise('method MAST overload.')
	end

	def _line(x1, y1, x2, y2, c, w, d, a)
		raise('method MAST overload.')
	end

	def polygon(points, c, f = '', w = 1)		# points = [[x1, y1], [x2, y2], [x3, y3]...]
		raise('method MAST overload.')
	end

	def pset(x, y, c)
		fill(x, y, x, y, c)
	end

	def line(x1, y1, x2, y2, c, bf = '', w = 1, d = nil, a = nil)
		if(bf =~ /f/i)
			fill(x1, y1, x2, y2, c)
		elsif(bf =~ /b/i)
			polygon([[x1, y1], [x2, y1], [x2, y2], [x1, y2]], c, 'c', w)
		else
			@lx = x2
			@ly = y2
			_line(x1, y1, x2, y2, c, w, d, a)
		end
	end

	def cline(x, y, c, w = 1, d = nil, a = nil)
			  x1 = @lx
			  y1 = @ly
		@lx = x2 = x
		@ly = y2 = y
		_line(x1, y1, x2, y2, c, w, d, a)
	end

	def circle(x, y, r, c)
		raise('not implement yet.')
	end

	def put_image_png(x, y, file)
		raise('method MAST overload.')
	end

	def text(x, y, s, c, ps = {})
		ps[:font_family] =~ /\.bmf$/ ?  _text_bmf(x, y, s, c, ps) : _text(x, y, s, c, ps)
	end

	def _text(x, y, s, c, ps = {})
		raise('method MAST overload.')
	end

	def locate(x, y)
		@tx = x * 8; @ty = y * 16
	end

	def print(mes, c = 7)
		text(@tx, @ty, mes, c)
	end

	def _text_bmf(x, y, s, c, ps = {})
#		{ 'font.family' => 'Helvetica', 'font.weight' => 400, 'font.size' => 10, 'layout.width' => 128, 'layout.alignment' => 'left', 'get_size' => true }

		@fonts ||= {}
		@fonts[font = ps[:font_family] || 'default.bmf'] ||= File.open(font)

		(it = ps[:font_size]) and (tx = it >> 3; ty = it >> 3)	# 8 -> 8dot
		tx ||= ps[:tx] || 1; ty ||= ps[:ty] || 2; raster = ps[:raster] || 0	# depend :ty

		wpad = 0; fsize = [s.size * tx * 8, ty * 8]
		ps[:get_size] and return(fsize)
		ps[:layout_alignment] =~ /right/i  and wpad =  ps[:layout_width] - fsize[0]
		ps[:layout_alignment] =~ /center/i and wpad = (ps[:layout_width] - fsize[0]) / 2

		cx = 0; cy = 0; s.each_byte {|code|
			if(code < 0x20)
				code == 0x0a and (cx = 0; cy += 1; next)
				code =  0x20
			end
			@fonts[font].seek(code * 8)
			bps = @fonts[font].read(8)
			ry = 0; bps.unpack('C*').each {|bp|
				rx = 0; while(bp != 0)
					px = (cx * 8 + rx) * tx; py = (cy * 8 + ry) * ty
					bp & 0x80 != 0 and fill(wpad + x + px, y + py, wpad + x + px + tx - 1, y + py + ty - 1 - raster, c)
					bp = (bp << 1) & 0xFF
					rx += 1
				end
				ry += 1
			}
			cx += 1
		}
	end

	def symbol(x, y, s, tx, ty, c)
		_text_bmf(x, y, s, c, ps = { :tx => tx, :ty => ty })
	end

	def rotate(r = nil, x = 0, y = 0)
		raise('not implement yet.')
	end

	def clear
	end

	def box(vchar_dmy, hchar_dmy)
	end

	def refresh(fps = nil)
		raise('method MAST overload.')
	end

	def getch
	end

	def close
	end
end

